"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.useActions = exports.ActionsContext = exports.defaultAction = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/*
 * Copyright (c) 2019, Globo.com (https://github.com/globocom)
 *
 * License: MIT
 */
var defaultAction = function defaultAction() {};

exports.defaultAction = defaultAction;

var ActionsContext = /*#__PURE__*/_react["default"].createContext({
  onAction: defaultAction
});

exports.ActionsContext = ActionsContext;

var useActions = function useActions() {
  return (0, _react.useContext)(ActionsContext);
};

exports.useActions = useActions;

var ActionsProvider = function ActionsProvider(_ref) {
  var _ref$onAction = _ref.onAction,
      onAction = _ref$onAction === void 0 ? defaultAction : _ref$onAction,
      children = _ref.children;
  return /*#__PURE__*/_react["default"].createElement(ActionsContext.Provider, {
    value: {
      onAction: onAction
    }
  }, children);
};

ActionsProvider.propTypes = {
  onAction: _propTypes["default"].func
};
var _default = ActionsProvider;
exports["default"] = _default;