"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _DropdownItem = _interopRequireDefault(require("./DropdownItem"));

var _icons = _interopRequireDefault(require("../icons"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var Dropdown = function Dropdown(_ref) {
  var _ref$items = _ref.items,
      items = _ref$items === void 0 ? [] : _ref$items,
      selected = _ref.selected,
      onChange = _ref.onChange;
  var wrapperRef = (0, _react.useRef)(null);

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      isOpen = _useState2[0],
      setIsOpen = _useState2[1];

  var isEmpty = items.length === 0;
  var selectedItem = items.filter(function (item) {
    return item.key === selected;
  })[0];

  var toggleDropdown = function toggleDropdown() {
    return setIsOpen(function (isOpen) {
      return !isOpen;
    });
  };

  var handleDocumentClick = function handleDocumentClick(event) {
    if (wrapperRef.current && !wrapperRef.current.contains(event.target)) {
      setIsOpen(false);
    }
  };

  var preventSelection = function preventSelection(event) {
    window.getSelection().empty();
    event.preventDefault();
  };

  (0, _react.useEffect)(function () {
    document.addEventListener("click", handleDocumentClick, false);
    return function () {
      return document.removeEventListener("click", handleDocumentClick, false);
    };
  }, []);

  if (isEmpty) {
    return null;
  }

  var wrapperClassName = (0, _classnames["default"])("dropdown__wrapper", {
    "dropdown__wrapper--open": isOpen
  });
  var dropdownClassName = (0, _classnames["default"])("dropdown", {
    "dropdown--open": isOpen
  });
  var arrowClassName = (0, _classnames["default"])("dropdown__arrow", {
    "dropdown__arrow--open": isOpen
  });
  return /*#__PURE__*/_react["default"].createElement("div", {
    ref: wrapperRef,
    className: wrapperClassName,
    onClick: toggleDropdown
  }, /*#__PURE__*/_react["default"].createElement(_DropdownItem["default"], {
    item: selectedItem,
    className: "dropdown__item--selected",
    onMouseDown: preventSelection
  }, /*#__PURE__*/_react["default"].createElement(_icons["default"].DropdownArrow, {
    className: arrowClassName
  })), /*#__PURE__*/_react["default"].createElement("ul", {
    className: dropdownClassName
  }, items.map(function (item) {
    return /*#__PURE__*/_react["default"].createElement("li", {
      key: item.key
    }, /*#__PURE__*/_react["default"].createElement(_DropdownItem["default"], {
      item: item,
      className: "dropdown__option",
      onClick: function onClick() {
        return onChange(item.key);
      }
    }));
  })));
};

Dropdown.propTypes = {
  items: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    key: _propTypes["default"].string.isRequired,
    icon: _propTypes["default"].func.isRequired,
    label: _propTypes["default"].string.isRequired
  })),
  selected: _propTypes["default"].string,
  onChange: _propTypes["default"].func.isRequired
};
var _default = Dropdown;
exports["default"] = _default;