"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = DropdownItem;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/*
 * Copyright (c) 2016, Globo.com (https://github.com/globocom)
 *
 * License: MIT
 */
function DropdownItem(props) {
  var Icon = props.item.icon;
  var className = (0, _classnames["default"])("dropdown__item ", props.className);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: className,
    onClick: props.onClick,
    onMouseDown: props.onMouseDown,
    onMouseUp: props.onMouseDown
  }, /*#__PURE__*/_react["default"].createElement(Icon, {
    className: "dropdown__item__icon"
  }), /*#__PURE__*/_react["default"].createElement("span", {
    className: "dropdown__item__text"
  }, props.item.label), props.children);
}

DropdownItem.propTypes = {
  item: _propTypes["default"].object.isRequired,
  style: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].array]),
  onClick: _propTypes["default"].func
};