"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _draftJs = require("draft-js");

var _ErrorBoundary = _interopRequireDefault(require("./ErrorBoundary"));

var _MediaWrapper = _interopRequireDefault(require("./MediaWrapper"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Media = function Media(_ref) {
  var blockProps = _ref.blockProps,
      block = _ref.block,
      rest = _objectWithoutProperties(_ref, ["blockProps", "block"]);

  var plugin = blockProps.plugin,
      setInitialReadOnly = blockProps.setInitialReadOnly,
      setReadOnly = blockProps.setReadOnly,
      i18n = blockProps.i18n;
  var Block = (0, _react.useMemo)(function () {
    return plugin.blockComponent;
  }, [plugin]);
  var data = (0, _react.useMemo)(function () {
    return block.getData().toJS();
  }, [block]);
  var remove = (0, _react.useCallback)(function () {
    var editorState = blockProps.getEditorState();
    var selection = editorState.getSelection();
    var content = editorState.getCurrentContent();
    var keyAfter = content.getKeyAfter(block.key);
    var blockMap = content.getBlockMap()["delete"](block.key);
    var withoutAtomicBlock = content.merge({
      blockMap: blockMap,
      selectionAfter: selection
    });

    var newState = _draftJs.EditorState.push(editorState, withoutAtomicBlock, "remove-range"); // if this is not the last block


    if (keyAfter) {
      var newSelection = new _draftJs.SelectionState({
        anchorKey: keyAfter,
        anchorOffset: 0,
        focusKey: keyAfter,
        focusOffset: block.getLength()
      });

      var newEditorState = _draftJs.EditorState.forceSelection(newState, newSelection);

      blockProps.onChange(newEditorState);
    } else {
      blockProps.onChange(newState);
    }
  }, [blockProps, block]);
  var updateData = (0, _react.useCallback)(function (data) {
    var editorState = blockProps.getEditorState();
    var content = editorState.getCurrentContent();
    var selection = new _draftJs.SelectionState({
      anchorKey: block.key,
      anchorOffset: 0,
      focusKey: block.key,
      focusOffset: block.getLength()
    });

    var newContentState = _draftJs.Modifier.mergeBlockData(content, selection, data);

    var newEditorState = _draftJs.EditorState.push(editorState, newContentState, "change-block-data");

    blockProps.onChange(newEditorState);
  }, [block, blockProps]);
  return /*#__PURE__*/_react["default"].createElement(_ErrorBoundary["default"], _extends({}, _objectSpread({
    blockProps: blockProps,
    block: block
  }, rest), {
    i18n: i18n,
    data: data,
    container: {
      updateData: updateData,
      remove: remove
    }
  }), /*#__PURE__*/_react["default"].createElement(_MediaWrapper["default"], {
    i18n: i18n,
    setInitialReadOnly: setInitialReadOnly,
    setReadOnly: setReadOnly
  }, /*#__PURE__*/_react["default"].createElement(Block, {
    i18n: i18n,
    data: data,
    container: {
      updateData: updateData,
      remove: remove
    },
    blockProps: blockProps
  })));
};

var _default = Media;
exports["default"] = _default;