"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/*
 * Copyright (c) 2016, Globo.com (https://github.com/globocom)
 *
 * License: MIT
 */

/*
 * MediaWrapper component avoids Draft JS bugs when a custom block component
 * is being updated by setting the editor's readOnly flag to true
 *
 * https://draftjs.org/docs/advanced-topics-block-components/#recommendations-and-other-notes
 */
var MediaWrapper = function MediaWrapper(_ref) {
  var setReadOnly = _ref.setReadOnly,
      setInitialReadOnly = _ref.setInitialReadOnly,
      children = _ref.children;

  var handleFocus = function handleFocus() {
    setReadOnly(true);
  };

  var handleBlur = function handleBlur() {
    setInitialReadOnly();
  };

  return /*#__PURE__*/_react["default"].createElement("div", {
    onBlur: handleBlur,
    onFocus: handleFocus
  }, children);
};

var _default = MediaWrapper;
exports["default"] = _default;