"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _backstageModal = _interopRequireDefault(require("backstage-modal"));

var _ModalPluginList = _interopRequireDefault(require("./ModalPluginList"));

var _constants = require("../constants");

var _ActionsProvider = require("./ActionsProvider");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/*
 * Copyright (c) 2016, Globo.com (https://github.com/globocom)
 *
 * License: MIT
 */
var PluginsModal = function PluginsModal(_ref) {
  var i18n = _ref.i18n,
      isOpen = _ref.isOpen,
      toggleModalVisibility = _ref.toggleModalVisibility,
      plugins = _ref.plugins,
      onChange = _ref.onChange,
      editorState = _ref.editorState,
      _ref$modalOptions = _ref.modalOptions,
      modalOptions = _ref$modalOptions === void 0 ? {} : _ref$modalOptions;

  var _useActions = (0, _ActionsProvider.useActions)(),
      onAction = _useActions.onAction;

  var _modalOptions$width = modalOptions.width,
      modalWidth = _modalOptions$width === void 0 ? 528 : _modalOptions$width,
      _modalOptions$height = modalOptions.height,
      modalHeight = _modalOptions$height === void 0 ? 394 : _modalOptions$height;
  var onCloseRequest = (0, _react.useCallback)(function () {
    if (!isOpen) {
      return;
    }

    document.body.classList.remove("megadraft-modal--open");
    onAction({
      type: _constants.PLUGINS_MODAL_CLOSE
    });
    toggleModalVisibility();
  }, [onAction, toggleModalVisibility, isOpen]);
  return /*#__PURE__*/_react["default"].createElement(_backstageModal["default"], {
    className: "megadraft-modal",
    title: i18n["Block List"],
    isOpen: isOpen,
    onCloseRequest: onCloseRequest,
    width: modalWidth,
    height: modalHeight
  }, /*#__PURE__*/_react["default"].createElement(_ModalPluginList["default"], {
    toggleModalVisibility: onCloseRequest,
    plugins: plugins,
    onChange: onChange,
    editorState: editorState
  }));
};

var _default = PluginsModal;
exports["default"] = _default;