"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = BlockActionGroup;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _BlockAction = _interopRequireDefault(require("./BlockAction"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/*
 * Copyright (c) 2016, Globo.com (https://github.com/globocom)
 *
 * License: MIT
 */
function BlockActionGroup(props) {
  function renderItem(item) {
    return /*#__PURE__*/_react["default"].createElement(_BlockAction["default"], {
      item: item,
      key: item.key
    });
  }

  return /*#__PURE__*/_react["default"].createElement("ul", {
    className: "block__action-group"
  }, props.items.map(renderItem));
}

BlockActionGroup.propTypes = {
  items: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    key: _propTypes["default"].string.isRequired,
    icon: _propTypes["default"].func.isRequired,
    action: _propTypes["default"].func.isRequired
  }))
};