"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = CommonBlock;

var _react = _interopRequireDefault(require("react"));

var _Dropdown = _interopRequireDefault(require("../../components/Dropdown"));

var _plugin = require("../../components/plugin");

var _defaults = require("../../components/plugin/defaults");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function CommonBlock(props) {
  function _handleDisplayChange(newValue) {
    props.container.updateData({
      display: newValue
    });
  }

  var data = props.data;
  var defaults = {
    defaultDisplay: _defaults.DEFAULT_DISPLAY_KEY,
    displayOptions: _defaults.DEFAULT_DISPLAY_OPTIONS
  };
  var options = props.blockProps.plugin.options || {};
  options = _objectSpread(_objectSpread({}, defaults), options);
  var readOnly = props.blockProps.getInitialReadOnly();
  return /*#__PURE__*/_react["default"].createElement(_plugin.BlockWrapper, {
    readOnly: readOnly
  }, !readOnly && /*#__PURE__*/_react["default"].createElement(_plugin.BlockControls, null, /*#__PURE__*/_react["default"].createElement(_Dropdown["default"], {
    items: options.displayOptions,
    selected: data.display || options.defaultDisplay,
    onChange: _handleDisplayChange
  }), /*#__PURE__*/_react["default"].createElement(_plugin.BlockActionGroup, {
    items: props.actions
  })), props.children);
}