"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = LinkInput;

var _react = _interopRequireWildcard(require("react"));

var _icons = _interopRequireDefault(require("../icons"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var addHttpPrefix = function addHttpPrefix(url) {
  if (!url.startsWith("http://") && !url.startsWith("https://")) {
    return "http://".concat(url);
  }

  return url;
};

var cancelErrorIfEmptyUrl = function cancelErrorIfEmptyUrl(urlEvent, cancelError) {
  if (urlEvent === "") {
    cancelError();
  }
};

var handleKey = function handleKey(event, setLink, reset) {
  if (event.key == "Enter") {
    event.preventDefault();
    setLink(event);
  } else if (event.key == "Escape") {
    event.preventDefault();
    reset();
  }
};

var isValidUrl = function isValidUrl(url) {
  // https://gist.github.com/dperini/729294
  // Author: Diego Perini
  // License: MIT
  // Updated: 2018/09/12
  var expression = /^(?:(?:(?:https?|ftp):)?\/\/)(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z0-9\u00a1-\uffff][a-z0-9\u00a1-\uffff_-]{0,62})?[a-z0-9\u00a1-\uffff]\.)+(?:[a-z\u00a1-\uffff]{2,}\.?))(?::\d{2,5})?(?:[/?#]\S*)?$/i;
  var regex = new RegExp(expression);
  return url.match(regex);
};

function LinkInput(_ref) {
  var cancelEntity = _ref.cancelEntity,
      cancelError = _ref.cancelError,
      entity = _ref.entity,
      i18n = _ref.i18n,
      removeEntity = _ref.removeEntity,
      setEntity = _ref.setEntity,
      setError = _ref.setError,
      url = _ref.url;
  var textInputRef = (0, _react.useRef)();

  var _useState = (0, _react.useState)(url !== null && url !== void 0 ? url : ""),
      _useState2 = _slicedToArray(_useState, 2),
      urlState = _useState2[0],
      setUrlState = _useState2[1];

  var setLink = function setLink(event) {
    var urlAux = addHttpPrefix(urlState);

    if (!isValidUrl(urlAux)) {
      var errorMsg = i18n["Invalid Link"];
      setError(errorMsg);
      textInputRef.current.focus();
      return;
    }

    setEntity({
      url: urlAux
    });
    reset(); // Force blur to work around Firefox's NS_ERROR_FAILURE

    event.target.blur();
  };

  var reset = function reset() {
    setUrlState("");
    cancelEntity();
  };

  var onLinkChange = function onLinkChange(event) {
    event.stopPropagation();
    var urlEvent = event.target.value;
    cancelErrorIfEmptyUrl(urlEvent, cancelError);
    setUrlState(urlEvent);
  };

  var onLinkKeyDown = function onLinkKeyDown(event) {
    handleKey(event, setLink, reset);
  };

  return /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      whiteSpace: "nowrap"
    }
  }, /*#__PURE__*/_react["default"].createElement("input", {
    autoFocus: true,
    ref: textInputRef,
    type: "text",
    className: "toolbar__input",
    onChange: onLinkChange,
    value: urlState,
    onKeyDown: onLinkKeyDown,
    placeholder: i18n["Type the link and press enter"]
  }), /*#__PURE__*/_react["default"].createElement("span", {
    className: "toolbar__item",
    style: {
      verticalAlign: "bottom"
    }
  }, /*#__PURE__*/_react["default"].createElement("button", {
    onClick: removeEntity,
    type: "button",
    className: "toolbar__button toolbar__input-button"
  }, entity ? /*#__PURE__*/_react["default"].createElement(_icons["default"].UnlinkIcon, null) : /*#__PURE__*/_react["default"].createElement(_icons["default"].CloseIcon, null))));
}