"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = BlockButton;

var _react = _interopRequireDefault(require("react"));

var _icons = _interopRequireDefault(require("../../icons"));

var _insertDataBlock = _interopRequireDefault(require("../../insertDataBlock"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/*
 * Copyright (c) 2016, Globo.com (https://github.com/globocom)
 *
 * License: MIT
 */
function BlockButton(props) {
  var onChange = props.onChange,
      editorState = props.editorState,
      className = props.className,
      title = props.title;

  function onClick(event) {
    event.preventDefault();
    var src = window.prompt("Enter an URL");

    if (!src) {
      return;
    }

    var data = {
      src: src,
      type: "image",
      display: "medium"
    };
    onChange((0, _insertDataBlock["default"])(editorState, data));
  }

  return /*#__PURE__*/_react["default"].createElement("button", {
    className: className,
    type: "button",
    onClick: onClick,
    title: title
  }, /*#__PURE__*/_react["default"].createElement(_icons["default"].ImageIcon, {
    className: "sidemenu__button__icon"
  }));
}