"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = NotFoundBlock;

var _react = _interopRequireDefault(require("react"));

var _plugin = require("../../components/plugin");

var _MediaMessage = _interopRequireDefault(require("../../components/MediaMessage"));

var _icons = _interopRequireDefault(require("../../icons"));

var _i18n = require("../../i18n");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function NotFoundBlock(props) {
  var container = props.container,
      i18n = props.i18n,
      type = props.data.type;
  var actions = [{
    key: "delete",
    icon: _icons["default"].DeleteIcon,
    action: container.remove
  }];
  var errorMsg = type ? "Can't show plugin, component {{type}} not found." : "Can't show plugin, component not found.";
  var text = (0, _i18n.replaceData)(i18n[errorMsg], {
    type: type && type.toString()
  });
  return /*#__PURE__*/_react["default"].createElement(_plugin.CommonBlock, _extends({}, props, {
    actions: actions
  }), /*#__PURE__*/_react["default"].createElement(_plugin.BlockContent, {
    className: "block__notfound"
  }, /*#__PURE__*/_react["default"].createElement(_MediaMessage["default"], {
    text: text,
    type: "warning"
  }), /*#__PURE__*/_react["default"].createElement(_icons["default"].ErrorIcon, {
    className: "block__notfound__icon"
  })));
}